"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _TreeBuilder = require("./builder/TreeBuilder");

var _ImportBuilder = require("./builder/ImportBuilder");

var _ExportBuilder = require("./builder/ExportBuilder");

var _ImportsTraversor = require("./traverse/ImportsTraversor");

var _ExportsTraversor = require("./traverse/ExportsTraversor");

var _provideModuleName = require("./util/parse/provideModuleName");

var _provideModuleName2 = _interopRequireDefault(_provideModuleName);

var _buildModuleDefinitionStatement = require("./util/stmt/buildModuleDefinitionStatement");

var _buildModuleDefinitionStatement2 = _interopRequireDefault(_buildModuleDefinitionStatement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
    var t = _ref.types;

    return {
        visitor: {
            Program: {
                enter: function enter(path, state) {
                    (0, _provideModuleName2.default)(state.file.opts.filename, function (moduleName) {
                        var iBuilder = new _ImportBuilder.ImportBuilder(),
                            eBuilder = new _ExportBuilder.ExportBuilder(),
                            treeBuilder = new _TreeBuilder.TreeBuilder("bem:"),
                            iTraversor = new _ImportsTraversor.ImportsTraversor(iBuilder),
                            eTraversor = new _ExportsTraversor.ExportsTraversor(path, eBuilder);
                        path.traverse(iTraversor.getVisitors());
                        path.traverse(eTraversor.getVisitors(t));
                        var tree = treeBuilder.importBuilder(iBuilder).exportBuilder(eBuilder).build(moduleName);
                        path.node.body = [(0, _buildModuleDefinitionStatement2.default)(t, tree, path.node.body)];
                    });
                }
            }
        }
    };
};

module.exports = exports["default"];