"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ImportsTraversor = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _provideImportData = require("../util/traverse/provideImportData");

var _provideImportData2 = _interopRequireDefault(_provideImportData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * This class traverses the ast tree and replace import
 * clauses to equivalent javascript code.
 * @author Dmitry Mikhaylenko
 */
var ImportsTraversor = exports.ImportsTraversor = function () {
    /**
     * @constructs ImportTraversor
     * @param {Object} ast root AST tree
     * @param {Object} builder export builder instance
     */
    function ImportsTraversor(builder) {
        _classCallCheck(this, ImportsTraversor);

        this.builder = builder;
    }

    /**
     * Returns the import visitors
     * @param {Object} t babel types
     * @returns {Object} visitors
     * @author Dmitry Mikhaylenko
     */


    _createClass(ImportsTraversor, [{
        key: "getVisitors",
        value: function getVisitors() {
            var builder = this.builder;
            return {
                ImportDeclaration: function ImportDeclaration(path) {
                    (0, _provideImportData2.default)(path, function (from, isExtended) {
                        builder.import(from, isExtended);
                        if (!isExtended) {
                            path.traverse(visitors(builder));
                        }
                        path.remove();
                    });
                }
            };
        }
    }]);

    return ImportsTraversor;
}();

function visitors(builder) {
    return {
        ImportSpecifier: function ImportSpecifier(path) {
            builder.importSpecifier(path.node.imported.name, path.node.local.name);
        },
        ImportDefaultSpecifier: function ImportDefaultSpecifier(path) {
            builder.importDefaultSpecifier(path.node.local.name);
        },
        ImportNamespaceSpecifier: function ImportNamespaceSpecifier(path) {
            builder.importNamespaceSpecifier(path.node.local.name);
        }
    };
}