"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

/**
 * This function helps to get property from the any object.
 * If object or property is undefined that this function
 * throws ReferenceError. In other cases this function
 * get property with specified name from the specified
 * object and send to callback as an argument. This
 * function returns the value which will returned by
 * callback function.
 * @param {Object} object object containing property
 * @param {string} property property name
 * @param {function} callback function which receives
 * as argument provided property and returns any value
 * @returns {*} the value returned by callback
 * @throws {ReferenceError} if object or property has null
 * or undefined value or property is empty string
 * @author Dmitry Mikhaylenko
 */

exports.default = function (object, property, callback) {
    if (!object || !property) {
        throw new ReferenceError("Processed requirement name is undefined");
    } else {
        return callback(object[property]);
    }
};

module.exports = exports["default"];