"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _provideObjectProperty = require("./provideObjectProperty");

var _provideObjectProperty2 = _interopRequireDefault(_provideObjectProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This function helps to get root element from the internal
 * imports definition tree. If object or property is undefined
 * that this function throws ReferenceError. In other cases
 * function gets the property with specified name and call the
 * specified callback function where it sends the got property
 * if property is defined or empty root object in other cases.
 * This function returns the value which will returned by
 * callback function.
 * @param {Object} object root object
 * @param {string} property root object property name
 * @param {function} callback function which receives the
 * as an argument provided root element and returns any value
 * @returns {*} the value returned by callback
 * @throws {ReferenceError} if object or property has null
 * or undefined value or property is empty string
 * @author Dmitry Mikhaylenko
 */
exports.default = function (object, property, callback) {
    return (0, _provideObjectProperty2.default)(object, property, function (prop) {
        return callback(prop ? prop : {});
    });
};

module.exports = exports["default"];