"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

/**
 * This callback provides the random salt
 * @param {function} callback function which receive 
 * random salt
 * @throws {ReferenceError} if the callback is null or undefined
 * @author Dmitry Mikhaylenko
 */
exports.default = function (callback) {
    if (!callback) {
        throw new ReferenceError("Arguments must not have null or undefined value");
    } else {
        return callback(Math.round(Math.random() * Number.MAX_SAFE_INTEGER));
    }
};

module.exports = exports["default"];