"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _provideSourceName = require("./provideSourceName");

var _provideSourceName2 = _interopRequireDefault(_provideSourceName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This function provides the correct import
 * data
 * @param {Object} path is path in AST tree
 * for AST tree element the import data is
 * provided for
 * @callback callback which receives import
 * data as arguments
 * @return {Object} object which will returned
 * by the callback
 * @throws {ReferenceError} if one of argument
 * have null or undefined value
 * @author Dmitry Mikhaylenko
 */
exports.default = function (path, callback) {
    if (!path || !callback) {
        throw new ReferenceError("Arguments must not have null or undefined value");
    } else {
        (0, _provideSourceName2.default)(path, function (from) {
            var isExtended = path.node.specifiers.length === 0;
            return callback(from, isExtended);
        });
    }
};

module.exports = exports["default"];