"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

/**
 * This function provides the correct source
 * name
 * @param {Object} path is path in AST tree 
 * for AST tree element the source path is
 * provided for
 * @callback callback which receives source
 * name as argument
 * @return {Object} object which will returned
 * by the callback
 * @author Dmitry Mikhaylenko
 */
exports.default = function (path, callback) {
    if (!path || !callback) {
        throw new ReferenceError("Arguments must not have null or undefined value");
    } else {

        return callback(path.node && path.node.source ? path.node.source.value : "*");
    }
};

module.exports = exports["default"];